package Frame;

public abstract class Frame
{
	// libreria di funzioni esterne
    public static java.util.Dictionary extRoutine = new java.util.Hashtable();

    //  nome della funzione
	public Temp.Label name;
    //  nome della funzione per il debug
	public Temp.Label debugName;

    // indica se e' escape
    public boolean main;
	public AccessList formals;
	public int countAlloc=0;

	abstract public Frame newFrame(Temp.Label name, Util.BoolList formals);
	abstract public Access allocLocal(boolean escape);
	abstract public Tree.Stm procEntryExit1(Tree.Stm body);
  
	abstract public Temp.Temp FP();
    abstract public Temp.Temp RV();
    abstract public int wordSize();
	abstract public int staticLinkOffset();

    public abstract Tree.Exp externalCall(String func, Tree.ExpList args);
    public abstract String string(Temp.Label lab, String lit);
}
