package Parse;

public class Parse
{
  public ErrorMsg.ErrorMsg errorMsg;

  public Parse(java.io.InputStream tigin, ErrorMsg.ErrorMsg errorMsg) 
  {
       this.errorMsg = errorMsg;

	   // analisi sintattica
       try {
          new parser(new Yylex(tigin, errorMsg), errorMsg)./*debug_*/parse();
       } catch (Throwable e) {
          //e.printStackTrace();
          //throw new Error(e.toString());
       } 
       try { tigin.close(); }
       catch(java.io.IOException e) {}

       if(parser.errorOccurred != 0) {
       	    if(parser.errorOccurred > 1)
       	    	System.out.println("\nProgramma tiger non valido: " + parser.errorOccurred + " errori\n");
       	    else
                System.out.println("\nProgramma tiger non valido: 1 errore\n");
       	    System.exit(1);
       }
       else
       	    System.out.println("\nAnalisi sintattica andata a buon fine\n");
    }

    // stampa albero della sintassi astratta
    public void print(java.io.PrintStream out)
    {
        out.println("\n---- Abstract Syntax");
        Absyn.Print absynPrinter = new Absyn.Print(out);
        absynPrinter.prExp((Absyn.Exp)parser.parseResult, 0);
        absynPrinter.say("\n\n");
    }
}
