package Translate;


// Lista linkata: container di nodi Exp

public class ExpList {
  ExpNode head;
  ExpNode last;
 
  public ExpList() {
    head = new ExpNode(null, null);
    last = head;
  }

  public ExpList(Exp e) {
    this();
    ExpNode node = new ExpNode(e, null);
    head.tail = node;
    last = node;
  }
  
  public void addInTail(Exp e) {
    ExpNode node = new ExpNode(e, null);
    last.tail = node;
    last = node;
  }

  public void addInFront(Exp e) {
    ExpNode node = new ExpNode(e, head.tail);
    head.tail = node;
  }

  public ExpNode first() {
    return head.tail;
  }

  public boolean empty() {
    return head.tail == null;
  }
}

