package Tree;

public class CJUMP extends Stm {
  public int relop;
  public Exp left, right;
  public Temp.Label iftrue, iffalse;

  public CJUMP(int rel, Exp l, Exp r, Temp.Label t, Temp.Label f) {
     relop = rel; 
     left = l; 
     right = r; 
     iftrue = t; 
     iffalse = f;
  }
  
  // FIXED: resi uguali a quelli di Absyn.OpExp
  public final static int ULT=0, ULE=1, UGT=2, UGE=3,
  	EQ=4, NE=5, LT=6, LE=7, GT=8, GE=9;
  
  public ExpList kids() {
    return new ExpList(left, new ExpList(right,null));
  }
  
  public Stm build(ExpList kids) {
    return new CJUMP(relop,kids.head,kids.tail.head,iftrue,iffalse);
  }
  
  public static int notRel(int relop) {
    switch (relop) {
        case EQ:  return NE;
        case NE:  return EQ;
	case LT:  return GE;
	case GE:  return LT;
	case GT:  return LE;
	case LE:  return GT;
	case ULT: return UGE;
	case UGE: return ULT;
	case UGT: return ULE;
	case ULE: return UGT;
	default: throw new Error("bad relop in CJUMP.notRel");
    }
  }
}

