#undef __STDC__

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>

int RV;
int Stack_Size;
int Stack_Init;
int Bound;

char * consts;
char * empty;


void init(){
  int i;
  empty=(char *)malloc(sizeof(char));
  (*empty)=0;
  consts=(char *)malloc(sizeof(char)*256*2);
  for(i=0;i<256;i++){
    consts[2*i]=i;
    consts[2*i+1]=0;
  }
}

void checkStack(int ESP){
  if (((Stack_Init-ESP)+Bound) > Stack_Size) {
    printf("[errore di runtime] stack overflow.\n");
    exit(0);
  }
}

int *initArray(int size, int init){
 int i;
 int *a = (int *)malloc(size);
 for(i=1;i<size/4;i++)a[i]=init;
 return a;
}

void printint(int x){printf("%d",x);}

void print(char *a){printf("%s",a);}

int stringEqual(int op,char *s, char *t){
  int app = strcmp(s,t);
	switch(op) {
		case 4: return app==0; // =
		case 5: return app!=0; // <>
		case 6: return app< 0; // <
		case 7: return app<=0; // <=
		case 8: return app> 0; // >
		case 9: return app>=0; // >=
	}
	return 0;
}

void flush(){fflush(stdout);}

int ord(char *c){
  if((*c)==0)return -1;
  return (*c);
}

char *chr(int c){
  if (c<0 || c>255){printf("[errore di runtime] chr(%d) fuori dai limiti [0,255]\n",c); exit(1);}
  return (&(consts[c*2]));
}


int size(char *s){
  int ret=0;
  while((*s)!=0){s++;ret++;}
  return ret;
}

char *substring(char *a, int primo, int n){
  char *ret,*m;
  int d=size(a);
  if((n<0)||(primo<0)||(primo>d)||((primo+n)>d)){
    printf("[errore di runtime] substring fuori dai limiti.\n");
    exit(1);
  }
  if(n==0)return empty;
  ret=(char*)malloc(sizeof(char)*(n+1));
  a=&(a[primo]);
  m=ret;
  while(n!=0){
    (*m)=(*a);
    a++;m++;n--;
  }
  (*m)=0;
  return ret;
}

char *concat(char *a, char *b){
  char *m;
  int n=size(a)+size(b)+1;
  char *ret=(char *)malloc(sizeof(char)*n);
  m=ret;
  while((*a)!=0){
    (*m)=(*a);
    m++;a++;
  }
  while((*b)!=0){
    (*m)=(*b);
    m++;b++;
  }
  (*m)=0;
  return ret;
}


int not(int i){return (i==0);}

char *getchar1(){
  int p=getc(stdin);
  if(p==EOF)return empty;
  return chr(p);
}

